from models import db
from models.{{ model['tableName'] }} import {{ model['className'] }}

class {{ contronller['className'] }}(object):
    def __init__(self):
        super({{ contronller['className'] }}, self).__init__()

    def get(self, params):
        # handle business
        result = {{ model['className'] }}.query.filter(*filters).order_by({{ model['className'] }}.areaId).paginate(params['pageNum'], params['pageSize'], error_out=False)

        return result

    def post(self, params):
        # handle business
        result = {{ model['className'] }}.query.filter({{ model['className'] }}.areaName == params['areaName']).first()
        if result and result.del_flag:
            result.del_flag = False
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            db.session.commit()
            return pretty_result(code.OK)
        elif result and result.del_flag == False:
            return pretty_result(code.EXISTS_ERROR)

        result = {{ model['className'] }}(**params)
        db.session.add(result)
        db.session.commit()
        return pretty_result(code.OK)

    def put(self, id, params):
        # handle business
        result = {{ model['className'] }}.query.get(id)
        if not result: return pretty_result(code.NO_DATA)
        if params:
            for key, value in params.items():
                if value != None: setattr(result, key, value)
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            db.session.commit()
        else:
            return pretty_result(code.PARAM_NULL)

    def delete(self, id):
        # handle business
        result = {{ model['className'] }}.query.get(id)
        if not result: return pretty_result(code.NO_DATA_FOUND)
        else:
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            result.del_flag = True
            db.session.delete(result)
            db.session.commit()
